#!/usr/bin/perl -w

# USE
use English;
use Getopt::Long;
use POSIX;

# CONF
if (-e "../conf/conf.inc") {
	require "../conf/conf.inc";
} else {
	print "ERROR: Your Aanvals /conf/conf.inc configuration file is not available.\n\n";
	print "Please see: http://www.aanval.com/?op=pub_docuWebView&id=86\n\n";
	exit;
}

if (!$aanvalAppsDir) {
	print "ERROR: \$aanvalAppsDir variable not defined! - Your conf.inc does not contain the correct information!\n\n";
	print "Please see: http://www.aanval.com/?op=pub_docuWebView&id=86\n\n";
	exit;
}

# DEFINES
my $start;
my $stop;
my $stopa;
my $stopb;
my $stopc;
my $help;

# OPTIONS
GetOptions (
		'start' => \$start,
		'stop' => \$stop,
		'stopa' => \$stopa,
		'stopb' => \$stopb,
		'stopc' => \$stopc,
		'help' => \$help
		);

launch();		
		
sub launch {

	print "Aanval Background Processing Unit (BPU) Initializer\n";

	my $run = 1;

# Removed on 12/13/05 @ 9:41 PST
# Change to Aanval's /apps directory
#	chdir("$aanvalAppsDir");	
	
	# Stopping
	if ($stop) {
		$stopa = 1;
		$stopb = 1;
		$stopc = 1;
	}
	
	if ($stopa) {
		print "Stopping BPU A\n";
		if (-e "pidA") { 
			system("kill -9 `cat $aanvalAppsDir/pidA` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidA");
			print "Stopped\n";
		} else {
			print "Nothing to stop\n";
		}
	} 
	if ($stopb) {
		print "Stopping BPU B\n";
		if (-e "pidB") { 
			system("kill -9 `cat $aanvalAppsDir/pidB` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidB");
			print "Stopped\n";
		} else {
			print "Nothing to stop\n";
		}
	}
	if ($stopc) {
		print "Stopping BPU C\n";
		if (-e "pidC") { 
			system("kill -9 `cat $aanvalAppsDir/pidC` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidC");
			print "Stopped\n";
		} else {
			print "Nothing to stop\n";
		}
	}
	
	if ($stop || $stopa || $stopb || $stopc) { exit; }
	
	# Exit immediately if this launch isn't going anywhere
	if (!$start && !$help) { print "\nNothing to do. Try -help\n\n"; $run = 0; }
	
	# Display Help
	if ($help) { displayHelp(); $run = 0; }

	if ($run == 1) {
		
		if (-e "pidA") { 
			system("kill -9 `cat $aanvalAppsDir/pidA` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidA");
		}
        system("perl $aanvalAppsDir/processorA.pl -start");
        
		if (-e "pidB") { 
			system("kill -9 `cat $aanvalAppsDir/pidB` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidB");
		}
        system("perl $aanvalAppsDir/processorB.pl -start");

		if (-e "pidC") { 
			system("kill -9 `cat $aanvalAppsDir/pidC` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidC");
		}
        system("perl $aanvalAppsDir/processorC.pl -start");

	}

	exit;
}

sub displayHelp {

	print "Usage: ./idsBackground.pl [options]\n\n";
	
	print "-start       Start all Aanval Background Processors\n";
	print "-stop        Stop all Aanval Background Processors\n";
	print "-stopa       Stop only BPU A (IMPORTER)\n";
	print "-stopb       Stop only BPU B (CORE)\n";
	print "-stopc       Stop only BPU C (INDEXER)\n";
	print "-help        This Help Information\n";
	print "\n";

}
