<?

// Tell the system we are in processor mode      :
$processor = 1;

// Set some initital variables
$processorVersion = "2.95";

// Includes
include "../conf/conf.php";
include "./processor.php";

// Load appropriate modules
recursiveModuleLoad();

// Simulate login to console
$login = new mySession("processor");

// Set Script TIMEOUT Value
set_time_limit(2000);

// Variable Initilization
$ops = new myOps();
$ops->loadOps();

// Away we go!
$start = date("U");

procWrite("B", "RESET");

procWrite("B", "----------------------------------------------------");
procWrite("B", ":: BPU: Background Processing Unit B v$processorVersion");
procWrite("B", ":: IDS: " . versionText());
procWrite("B", ":: Last processing finished " . statusProcessorLastRunDiff("B") . " seconds ago.");
procWrite("B", "----------------------------------------------------\n");

remoteVersionCheck();
remoteBulletinCheck();
permissionsCheck();

// Community Communication
communityBufferProcess();

// CUT idsMain DOWN TO SIZE
pruneIdsMain();

// CUT idsLogs DOWN TO SIZE
pruneIdsLogs();

// Delete Ignored Events
deleteIgnoredEvents();

// Archive Processor
archiveTableProcessor();

// IP to Hostname Lookups
hostnameLookup();

// OAD
$oadProcess = oadProcess();

$objStatus = new myStatus();
$objStatus->loadStatus();
$objStatus->setStatusVar("processorB_lastRun", date("U"));
if ($oadProcess == 1) $objStatus->setStatusVar("oad_lastUpload", date("U"));
if ($oadProcess == 1) $objStatus->totalOadUploadIncrement();
$objStatus->totalProcessorRunIncrement("B");
$objStatus->saveStatus();

// Action Processor
actionProcessor();

// Scanner
scanProcessor();

// Signature System
sigProcessor();

// AI (Artificial Intelligence)
aiProcessor();

// Daily Reports
processDailyReports();

// Mail Processor
processMail();

$end = date("U");
$seconds = $end - $start;

// Defaults
if (!$opsSetCount) $opsSetCount = 0;
if (!$opsGetCount) $opsGetCount = 0;

procWrite("B", "----------------------------------------------------");
procwrite("B", ":: Set ($opsSetCount)");
procwrite("B", ":: Get ($opsGetCount)");
procWrite("B", ":: Complete - $seconds");
procWrite("B", "----------------------------------------------------");

exit;

?>
