<?

function sendmail($fromEmail, $fromName, $toEmail, $toName, $subject, $message, $deliver = 0) {
    global $login, $ops;

    $epoch = date("U");
    $uid = $login->getSessionVar("id");

    if ($deliver == 0) {
        $deliver = $epoch;
    }

    $subject = addslashes($subject);
    $message = addslashes($message);
    $message .= "\n\n---\nThis message was generated from the Aanval Intrusion Detection Console.\nhttp://www.aanval.com/\n---\n";

    $idsDB = new idsDB;

    if (strstr($to_email, ",")) {
        $list = explode(",", $to_email);
        for ($n=0;$n<count($list);$n++) {
            $list[$n] = trim($list[$n]);
            $idsQueryA = $idsDB->query("insert into idsEmail (uid, fromName, fromEmail, toName, toEmail, subject, message, intime, sent, deliver)
            values ('$uid', '$fromName', '$fromEmail', '$list[$n]', '$list[$n]', '$subject', '$message', '$epoch', 0, '$deliver')");
        }
    } else {
        $idsQueryA = $idsDB->query("insert into idsEmail (uid, fromName, fromEmail, toName, toEmail, subject, message, intime, sent, deliver)
        values ('$uid', '$fromName', '$fromEmail', '$toName', '$toEmail', '$subject', '$message', '$epoch', 0, '$deliver')");
    }
}

function processMail() {
	global $ops;

	procWrite("B", ".. Mail Processing Started");

	// Retrieve current unix epoch for query
	$epoch = date("U");
	
	// Instantiate new database object
    $idsDB = new idsDB;
    
    // Set limit to default or use Flood Limit if Protection enabled
    if ($ops->getOpsVar("site_emailFloodProtection") == 1) {
    	$limit = $ops->getOpsVar("site_emailFloodLimit");
	} else {
		$limit = 100;
	}
    
    // Query email table within the aanval database for all emails which have a delivery time less than the current epoch (retrieved above)
    $idsQueryA = $idsDB->query("select id, fromName, fromEmail, toName, toEmail, subject, message, deliver from idsEmail where sent = 0 and deliver < '$epoch' order by deliver limit $limit");
    while (list($id, $fromName, $fromEmail, $toName, $toEmail, $subject, $message, $deliver) = mysql_fetch_row($idsQueryA)) {

    	// Check if Flood Protection is needed (in combination with LIMIT in query above, this should help prevent flooding)
    	if ($ops->getOpsVar("site_emailFloodProtection") == 1) {
	    	if ($headers) {
	    		procWrite("B", " . Flood Protection");
	    		
	    		// Check for previous toEmail equaling current toEmail (if true, then we increase the sleep period)
	    		if ($tmpTo == $toEmail) {
	    			sleep(15);
	    		} else {
	    			sleep(5);
	    		}
	
	    		// Set $tmpTo variable for checking next loop
	    		$tmpTo = $toEmail;
	    	}
    	}
    	
    	// Generate new unix timestamp for the send date/time
    	$sentDate = date("U");
    	
    	// Set basic headers
        $headers = "From: " . $fromName . " <" . $fromEmail . ">\r\n";

        // Set subject
        $subject = stripslashes($subject);
        
        // Set body / message
        $message = stripslashes($message);

        // Check to see if system is using sendmail or built-in php mail() function
        if ($ops->getOpsVar("site_sendmailEnabled") == 1) {
        	
        	// Check to ensure variable is not empty
        	if ($ops->getOpsVar("site_sendmailLocal") != "") {
        	
	        	procWrite("B", " . Using sendmail for email transmission");

	        	// Check to ensure the sendmail binary file handle is opened correctly
	        	if ($fd = popen($ops->getOpsVar("site_sendmailLocal"), 'w')) {
					
	        		// Write details to binary handle
					fputs($fd, "To: $toEmail\n"); 
					fputs($fd, "Subject: $subject\n"); 
					fputs($fd, "X-Mailer: PHP4\n"); 
					
					// Check to see if headers are empty and write if available
					if ($headers != "") {
						fputs($fd, "$headers\n"); 
					} 
					
					// Write body / message to binary handle
					fputs($fd, "\n"); 
					fputs($fd, $message); 
					
					// Close binary handle
					pclose($fd);
					
					procWrite("B", " . To: $toEmail");
					
	        	} else {
	        		
	        		// Handle could not be opened
					procWrite("B", " ! File Error: " . $ops->getOpsVar("site_sendmailLocal") . " - Current user does not have valid permissions OR this binary loction is incorrect");
					
					// Set notSent variable
					$notSent = 1;
	        	}
        	}
			
        } else {     
        	
        	procWrite("B", " . Using PHP for email transmission");

        	// Attempt to send mail - appropriate message regardless
			if (mail($toEmail, $subject, $message, $headers)) {
	        	procWrite("B", " . To: $toEmail");
			} else {

	        	// Set notSent variable
				$notSent = 1;
			}
			
        }

        // Check to see if message was not sent
        if (!$notSent) {

        	// Update database; set sent variable = 1 if message sent successfuly
        	$idsQueryB = $idsDB->query("update idsEmail set sent = 1, senttime = '$sentDate' where id = $id");
        	
        } else {
        	procWrite("B", " ! Mail Error: Message to [$toEmail] not sent");
        }
       
    }
    
    // Close database handle
    $idsDB->close();
        
    procWrite("B", " . Mail Processing Finished");
}

?>
