<?php

// MARK_POLL: Responsible for marking & unmarking ips

include "../conf/conf.php";

// Tell the system we are in processor mode
$processor = 1;

// Load /modules/ directory recursively
recursiveModuleLoad();

// Get Primary Variables
$xdu = getVar("xdu");
$mark = getVar("mark");
$s = getVar("s");
$t = getVar("t");

// Simulate login to console
$login = new mySession("processor");
$login->setSessionVar("backgroundUser", $xdu);
$login->initSession($xdu, "");
$login->loadSession();

// Variable Initilization
$ops = new myOps();
$ops->loadOps();

main($xdu, $mark, $s, $t);

function main($user, $mark, $s, $t) {

    markToggle($mark, $user, $t);
}

function loadSession($user) {

	$login = new mySession("processor");
	$login->setSessionVar("backgroundUser", $user);
	$login->initSession($user, "");
	$login->loadSession();

	return $login;
}

function recursiveModuleLoad() {
    global $root_path;

    # Read in all available modules recursively
    if (!$this_dir = @dir("$root_path/modules/")) {
        echo "conf.php ERROR:<p>\$root_path not correct or $root_path/modules/ not found! Check your conf.php settings<p>Exiting.";
        exit;
    }
    while ($dir = $this_dir->read()) {
        if ($dir != "." && $dir != "..") {
            if (substr($dir, -4, 4) == "_MOD") {
                $this_sub = dir("$root_path/modules/$dir");
                while ($file = $this_sub->read()) {
                    if ($file != "." && $file != "..") {
                        if (substr($file, 0,4) == "inc_") {
                            include "../modules/$dir/$file";
                        }
                    }
                }
            }
        }
    }
}

?>

